#version 330
layout (points) in; // points in
layout (triangle_strip, max_vertices = 4) out; // quads out

// uniform mat4 ProjectionMatrix;
uniform mat4 vpMatrix;
uniform mat4 modelMatrix;
uniform vec3 cameraPos;
uniform float partSize;

in vData { float TTL1; } vertex[]; // from vertex shader

out vec2 TexCoord0;
out vec4 orig_position;

flat out float TTL0; // flat: no interpolation between vertices

void main (void) {
    vec4 position = gl_in[0].gl_Position;
    mat4 mvpMatrix = vpMatrix * modelMatrix;

    // TODO: get actual up vector
    //******************************* calculate right and up vectors
    vec3 _up = vec3(0, 1, 0);
    vec4 tmpPos = position;
    _up = normalize(vec3( (modelMatrix * vec4(_up, 1.0)).xyz ));
    tmpPos = modelMatrix * tmpPos;

    vec3 view = tmpPos.xyz - cameraPos;
    view = normalize(view);
    vec3 rightVec = cross(view, _up);
    rightVec = normalize(rightVec);
    float len = partSize;
    //*******************************

    gl_Position = vpMatrix * vec4(position.xyz + (_up + rightVec) * len, 1.0);
    TexCoord0 = vec2(1.0, 1.0);
    TTL0 = vertex[0].TTL1;
    orig_position = vec4(position.xyz + (_up + rightVec) * len, 1.0);
    EmitVertex();
    
    gl_Position = vpMatrix * vec4(position.xyz + (_up -rightVec) * len, 1.0);
    TexCoord0 = vec2(0.0, 1.0);
    TTL0 = vertex[0].TTL1;
    orig_position = vec4(position.xyz + (_up -rightVec) * len, 1.0);
    EmitVertex();

    gl_Position = vpMatrix * vec4(position.xyz + (-_up + rightVec) * len, 1.0);
    TexCoord0 = vec2(1.0, 0.0);
    TTL0 = vertex[0].TTL1;
    orig_position = vec4(position.xyz + (-_up + rightVec) * len, 1.0);
    EmitVertex();
    
    gl_Position = vpMatrix * vec4(position.xyz + (-_up - rightVec) * len, 1.0);
    TexCoord0 = vec2(0.0, 0.0);
    TTL0 = vertex[0].TTL1;
    orig_position = vec4(position.xyz + (-_up - rightVec) * len, 1.0);
    EmitVertex();

    EndPrimitive();
}
