#version 430 core

out vec4 FragColor;
in vec2 TexCoord;

uniform sampler2D gFragColor;
uniform sampler2D gMotionVec;
uniform int g_numSamples;

void main() {
    // FragColor = vec4(1, 0.5, 0, 1.0);
    // FragColor = texture2D(gFragColor, TexCoord);

    vec2 texCoord = TexCoord;
    // vec4 motion_vector = texture(gMotionVec, texCoord);
    vec2 motion_vector = texture(gMotionVec, texCoord).xy;

    vec3 color = texture(gFragColor, texCoord).rgb;
    texCoord += motion_vector.xy;
    for(int i = 1; i < g_numSamples; ++i, texCoord += motion_vector)
    {
        // if(texCoord.x < 0) texCoord.x = 0;
        // if(texCoord.y < 0) texCoord.y = 0;

        // Sample the color buffer along the velocity vector.
        vec3 currentColor = texture(gFragColor, texCoord).rgb;
        // Add the current color to our color sum.

        color += currentColor;
    }
    // Average all of the samples to get the final blur color.
    color = color / g_numSamples;

    FragColor = vec4(color, 1.0);
}