#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;
layout(location = 3) in vec3 tangent;
layout(location = 4) in vec3 bitangent;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
	mat3 TBN;
} vert;

out vec3 prev_position;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

void main() {
	vert.normal_world = normalMatrix * normal;
	vert.uv = uv;
	vec4 position_world_ = vec4(position, 1);
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * modelMatrix * position_world_;

	
	vec3 T = normalize(vec3(modelMatrix * vec4(tangent, 0.0)));
	vec3 N = normalize(vec3(modelMatrix * vec4(normal, 0.0)));
	vec3 B = normalize(vec3(modelMatrix * vec4(bitangent, 0.0)));

	vert.TBN = mat3(T,B,N);

	// gl_Position = position_world_;
}